using Connected.Host.Configuration;

namespace Connected.Host
{
	public static partial class Program
	{
		public static async Task Main(params string[] args)
		{
			using IHost host = Microsoft.Extensions.Hosting.Host
				.CreateDefaultBuilder(args)
				.ConfigureAppConfiguration((_, cfg) =>
				{
					var appPath = AppContext.BaseDirectory;
					var segments = new Uri(appPath).Segments;

					segments = segments.Select(e => e.Replace("%20", " ")).ToArray();

					for (var i = 1; i <= segments.Length; i++)
					{
						var pathBase = Path.Combine(segments[0..i]);
						var filePath = Path.Combine(pathBase, "sys.json");

						if (File.Exists(filePath))
						{
							cfg.AddJsonFile(filePath, true, false);
							break;
						}
					}

					cfg.AddEnvironmentVariables();
				})
				.ConfigureServices((context, services) =>
				{
					services.Configure<SysConfiguration>(context.Configuration);
					services.AddHostedService<ConnectedPlatformService>();
				})
				.Build();

			await host.RunAsync();
		}
	}
}